package RideOnClick
{
	function Vehicle::onActivate(%this, %obj, %client, %pos, %vec)
	{
		if(%obj.isMounted()) //Prevents all kind of problems that could stem from using this while mounted.
		{
			Parent::onActivate(%this, %obj, %client, %pos, %vec);
			return;
		}
		%origPos = %obj.getTransform();
		%obj.setTransform(vectorAdd("0 0 500", %origPos)); //The vehicle and player can't be at the same altitude for the collision to mount the player.
		%this.getDatablock().onCollision(%this, %obj, 0, 0); //Last two values are irrelevant. Calling from the datablock because calling from the object just sends a message to the console.
		if(!%obj.isMounted()) //If mounting failed for any reason...
		{
			%obj.setTransform(%origPos); //They'll never even know...
			Parent::onActivate(%this, %obj, %client, %pos, %vec);
		}
	}
	
	function Player::activateStuff(%obj) //Hack factor increased by 3.5 because of no Player::onActivate.
	{
		Parent::activateStuff(%obj);
		if(%obj.isMounted())
			return;
		%client = %obj.client;
		%target = containerRayCast(%obj.getEyePoint(), vectorAdd(vectorScale(vectorNormalize(%obj.getEyeVector()), 10), %obj.getEyePoint()), $typeMasks::playerObjectType, %obj);
		if(!isObject(%target))
			return;
		if(!%target.getDatablock().rideable || %target == %obj)
			return;
		%origPos = %obj.getTransform();
		%obj.setTransform(vectorAdd("0 0 500", %origPos)); //The vehicle and player can't be at the same altitude for the collision to mount the player.
		%target.getDatablock().onCollision(%target, %obj, 0, 0); //Last two values are irrelevant. Calling from the datablock because calling from the object just sends a message to the console.
		if(!%obj.isMounted()) //If mounting failed for any reason...
			%obj.setTransform(%origPos); //They'll never even know...
	}
};
activatePackage(RideOnClick);